diff -uNrd ircd-hybrid-6.0/include/m_commands.h ircd-pi1.0a/include/m_commands.h
--- ircd-hybrid-6.0/include/m_commands.h	Fri Jul 30 22:44:44 1999
+++ ircd-pi1.0a/include/m_commands.h	Wed May 22 07:07:10 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: m_commands.h,v 1.3 1999/07/31 02:44:44 tomh Exp $
+ * $Id: m_commands.h,v 1.5 2002/05/22 11:07:10 smoli Exp $
  */
 #ifndef INCLUDED_m_commands_h
 #define INCLUDED_m_commands_h
@@ -31,6 +31,7 @@
 
 extern int m_admin(struct Client *,struct Client *,int,char **);
 extern int m_kline(struct Client *,struct Client *,int,char **);
+extern int m_ungline(struct Client *,struct Client *,int,char **);
 extern int m_unkline(struct Client *,struct Client *,int,char **);
 extern int m_dline(struct Client *,struct Client *,int,char **);
 
@@ -40,6 +41,11 @@
 
 extern int m_private(struct Client *,struct Client *,int,char **);
 extern int m_knock(struct Client *,struct Client *,int,char **);
+extern int m_spoof(struct Client *,struct Client *,int,char **);
+#ifdef HAVE_SSL
+extern int m_cert(struct Client *,struct Client *,int,char **);
+#endif
+extern int m_broadcast(struct Client *,struct Client *,int,char **);
 extern int m_topic(struct Client *,struct Client *,int,char **);
 extern int m_join(struct Client *,struct Client *,int,char **);
 extern int m_part(struct Client *,struct Client *,int,char **);
diff -uNrd ircd-hybrid-6.0/include/m_gline.h ircd-pi1.0a/include/m_gline.h
--- ircd-hybrid-6.0/include/m_gline.h	Thu Aug 24 20:20:41 2000
+++ ircd-pi1.0a/include/m_gline.h	Sun Mar 17 13:43:47 2002
@@ -19,7 +19,7 @@
  *
  * "m_gline.h". - Headers file.
  *
- * $Id: m_gline.h,v 1.4 2000/08/25 00:20:41 lusky Exp $
+ * $Id: m_gline.h,v 1.2 2002/03/17 18:43:47 shifty Exp $
  *
  */
 
@@ -44,6 +44,7 @@
 extern struct ConfItem* find_is_glined(const char *, const char *);
 extern void   flush_glines(void);             
 extern void   report_glines(struct Client *); 
+extern int    remove_gline_match(char *host, char *user);
 
 typedef struct gline_pending
 {
@@ -54,12 +55,12 @@
   char *reason1;
   time_t time_request1;
 
-  char oper_nick2[NICKLEN + 1];
+/*  char oper_nick2[NICKLEN + 1];
   char oper_user2[USERLEN + 1];
   char oper_host2[HOSTLEN + 1];
-  const char* oper_server2;     /* point to scache */
+  const char* oper_server2;     // point to scache
   char *reason2;
-  time_t time_request2;
+  time_t time_request2;*/
   
   time_t last_gline_time;       /* for expiring entry */
   char user[USERLEN + 1];
diff -uNrd ircd-hybrid-6.0/include/m_info.h ircd-pi1.0a/include/m_info.h
--- ircd-hybrid-6.0/include/m_info.h	Fri Nov 24 13:51:13 2000
+++ ircd-pi1.0a/include/m_info.h	Fri Nov  2 19:23:22 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: m_info.h,v 1.6 2000/11/24 18:51:13 lusky Exp $
+ * $Id: m_info.h,v 1.1.1.1 2001/11/03 00:23:22 shifty Exp $
  */
 #ifndef INCLUDED_m_info_h
 #define INCLUDED_m_info_h
diff -uNrd ircd-hybrid-6.0/include/m_kline.h ircd-pi1.0a/include/m_kline.h
--- ircd-hybrid-6.0/include/m_kline.h	Fri Jul 30 02:48:11 1999
+++ ircd-pi1.0a/include/m_kline.h	Fri Nov  2 19:23:22 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: m_kline.h,v 1.4 1999/07/30 06:48:11 tomh Exp $
+ * $Id: m_kline.h,v 1.1.1.1 2001/11/03 00:23:22 shifty Exp $
  */
 #ifndef INCLUDED_m_kline_h
 #define INCLUDED_m_kline_h
diff -uNrd ircd-hybrid-6.0/include/motd.h ircd-pi1.0a/include/motd.h
--- ircd-hybrid-6.0/include/motd.h	Sun Jul 25 14:05:06 1999
+++ ircd-pi1.0a/include/motd.h	Fri Nov  2 19:23:22 2001
@@ -1,7 +1,7 @@
 /*
  * motd.h
  *
- * $Id: motd.h,v 1.7 1999/07/25 18:05:06 tomh Exp $
+ * $Id: motd.h,v 1.1.1.1 2001/11/03 00:23:22 shifty Exp $
  */
 #ifndef INCLUDED_motd_h
 #define INCLUDED_motd_h
diff -uNrd ircd-hybrid-6.0/include/msg.h ircd-pi1.0a/include/msg.h
--- ircd-hybrid-6.0/include/msg.h	Wed Nov  8 22:46:52 2000
+++ ircd-pi1.0a/include/msg.h	Wed May 22 07:07:10 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: msg.h,v 1.14 2000/11/09 03:46:52 lusky Exp $
+ * $Id: msg.h,v 1.5 2002/05/22 11:07:10 smoli Exp $
  */
 #ifndef INCLUDED_msg_h
 #define INCLUDED_msg_h
@@ -119,13 +119,18 @@
 #define MSG_SET      "SET"      /* SET */
 
 #define MSG_GLINE    "GLINE"    /* GLINE */
-
+#define MSG_UNGLINE  "UNGLINE"	/* UNGLINE */
 
 #define MSG_LOCOPS   "LOCOPS"   /* LOCOPS */
 #ifdef LWALLOPS
 #define MSG_LWALLOPS "LWALLOPS" /* Same as LOCOPS */
 #endif /* LWALLOPS */
 #define MSG_KNOCK          "KNOCK"  /* KNOCK */
+#define MSG_SPOOF          "SPOOF"  /* SPOOF */
+#ifdef HAVE_SSL
+#define MSG_CERT           "CERT"   /* CERT */
+#endif
+#define MSG_BROADCAST      "BROADCAST" /* BROADCAST */
 
 #define MAXPARA    15 
 
@@ -166,6 +171,11 @@
   { MSG_QUIT,    m_quit,     0, MAXPARA, 1, 1, 0, 0L },
   { MSG_PART,    m_part,     0, MAXPARA, 1, 0, 0, 0L },
   { MSG_KNOCK,   m_knock,    0, MAXPARA, 1, 0, 0, 0L },
+  { MSG_SPOOF,   m_spoof,    0, MAXPARA, 1, 0, 0, 0L },
+#ifdef HAVE_SSL
+  { MSG_CERT,    m_cert,     0, MAXPARA, 1, 0, 0, 0L },
+#endif      
+  { MSG_BROADCAST, m_broadcast, 0, MAXPARA, 1, 0, 0, 0L },    
   { MSG_TOPIC,   m_topic,    0, MAXPARA, 1, 0, 0, 0L },
   { MSG_INVITE,  m_invite,   0, MAXPARA, 1, 0, 0, 0L },
   { MSG_KICK,    m_kick,     0, MAXPARA, 1, 0, 0, 0L },
@@ -239,6 +249,7 @@
   { MSG_UNKLINE, m_unkline,  0, MAXPARA, 1, 0, 0, 0L },
   { MSG_DLINE,   m_dline,    0, MAXPARA, 1, 0, 0, 0L },
   { MSG_GLINE,   m_gline,    0, MAXPARA, 1, 0, 0, 0L },
+  { MSG_UNGLINE, m_ungline,  0, MAXPARA, 1, 0, 0, 0L },
   { MSG_HASH,    m_hash,     0, MAXPARA, 1, 0, 0, 0L },
   { MSG_DNS,     m_dns,      0, MAXPARA, 1, 0, 0, 0L },
   { MSG_REHASH,  m_rehash,   0, MAXPARA, 1, 0, 0, 0L },
diff -uNrd ircd-hybrid-6.0/include/mtrie_conf.h ircd-pi1.0a/include/mtrie_conf.h
--- ircd-hybrid-6.0/include/mtrie_conf.h	Sat Jul 31 19:45:48 1999
+++ ircd-pi1.0a/include/mtrie_conf.h	Fri Nov  2 19:23:22 2001
@@ -1,4 +1,4 @@
-/* $Id: mtrie_conf.h,v 1.6 1999/07/31 23:45:48 db Exp $ */
+/* $Id: mtrie_conf.h,v 1.1.1.1 2001/11/03 00:23:22 shifty Exp $ */
 #ifndef INCLUDED_mtrie_conf_h
 #define INCLUDED_mtrie_conf_h
 
diff -uNrd ircd-hybrid-6.0/include/numeric.h ircd-pi1.0a/include/numeric.h
--- ircd-hybrid-6.0/include/numeric.h	Thu Dec 23 02:10:51 1999
+++ ircd-pi1.0a/include/numeric.h	Thu May 23 00:22:22 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: numeric.h,v 1.16 1999/12/23 07:10:51 lusky Exp $
+ * $Id: numeric.h,v 1.7 2002/05/23 04:22:22 smoli Exp $
  */
 #ifndef INCLUDED_numeric_h
 #define INCLUDED_numeric_h
@@ -175,6 +175,7 @@
 
 #define RPL_STATSFLINE       224
 #define RPL_STATSDLINE       225
+#define RPL_STATSSSL         226
 
 #define RPL_SERVLIST         234
 #define RPL_SERVLISTEND      235
@@ -204,8 +205,12 @@
 
 #define RPL_LOCALUSERS       265
 #define RPL_GLOBALUSERS      266
+#define RPL_LOCALSSL         267
+#define RPL_REACHSSL         268
 
 /* numeric_replies */
+#define RPL_WHOISSSL         275
+#define RPL_NOTSSL           276
 
 #define RPL_NONE             300
 #define RPL_AWAY             301
@@ -215,6 +220,8 @@
 #define RPL_UNAWAY           305
 #define RPL_NOWAWAY          306
 
+#define RPL_WHOISINFO        309
+#define RPL_WHOISENFORCE     310
 #define RPL_WHOISUSER        311
 #define RPL_WHOISSERVER      312
 #define RPL_WHOISOPERATOR    313
@@ -326,6 +333,7 @@
 #define ERR_YOUWILLBEBANNED  466
 #define ERR_KEYSET           467
 
+#define ERR_NEEDSSL          470
 #define ERR_CHANNELISFULL    471
 #define ERR_UNKNOWNMODE      472
 #define ERR_INVITEONLYCHAN   473
diff -uNrd ircd-hybrid-6.0/include/packet.h ircd-pi1.0a/include/packet.h
--- ircd-hybrid-6.0/include/packet.h	Sat Sep  4 16:21:08 1999
+++ ircd-pi1.0a/include/packet.h	Fri Nov  2 19:23:23 2001
@@ -19,7 +19,7 @@
  *
  * "packet.h". - Headers file.
  *
- * $Id: packet.h,v 1.2 1999/09/04 20:21:08 lusky Exp $
+ * $Id: packet.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $
  *
  */
 #ifndef INCLUDED_packet_h
diff -uNrd ircd-hybrid-6.0/include/parse.h ircd-pi1.0a/include/parse.h
--- ircd-hybrid-6.0/include/parse.h	Mon Jul 26 01:46:35 1999
+++ ircd-pi1.0a/include/parse.h	Fri Nov  2 19:23:23 2001
@@ -20,7 +20,7 @@
  * "parse.h". - Headers file.
  *
  *
- * $Id: parse.h,v 1.3 1999/07/26 05:46:35 tomh Exp $
+ * $Id: parse.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $
  *
  */
 #ifndef INCLUDED_parse_h_h
diff -uNrd ircd-hybrid-6.0/include/patchlevel.h ircd-pi1.0a/include/patchlevel.h
--- ircd-hybrid-6.0/include/patchlevel.h	Wed Jan  3 22:14:27 2001
+++ ircd-pi1.0a/include/patchlevel.h	Sun May  5 23:02:16 2002
@@ -14,8 +14,16 @@
  *   You should have received a copy of the GNU General Public License
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * 
+ *   $Id: patchlevel.h,v 1.7 2002/05/06 03:02:16 smoli Exp $
  */
 
+#include "setup.h"
+
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "2.8/hybrid-6.0"
+#ifndef HAVE_SSL
+#define PATCHLEVEL    "2.8/"VERSION
+#else
+#define PATCHLEVEL    "2.8/"VERSION"+ssl"
+#endif
 #endif
diff -uNrd ircd-hybrid-6.0/include/res.h ircd-pi1.0a/include/res.h
--- ircd-hybrid-6.0/include/res.h	Thu Oct  5 23:00:56 2000
+++ ircd-pi1.0a/include/res.h	Fri Nov  2 19:23:23 2001
@@ -1,7 +1,7 @@
 /*
  * include/res.h (C)opyright 1992 Darren Reed.
  *
- * $Id: res.h,v 1.14 2000/10/06 03:00:56 lusky Exp $
+ * $Id: res.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $
  */
 #ifndef INCLUDED_res_h
 #define INCLUDED_res_h
diff -uNrd ircd-hybrid-6.0/include/restart.h ircd-pi1.0a/include/restart.h
--- ircd-hybrid-6.0/include/restart.h	Thu Oct  5 23:00:57 2000
+++ ircd-pi1.0a/include/restart.h	Fri Nov  2 19:23:23 2001
@@ -1,5 +1,5 @@
 /*
- * $Id: restart.h,v 1.4 2000/10/06 03:00:57 lusky Exp $ 
+ * $Id: restart.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $ 
  */
 
 #ifndef INCLUDED_restart_h
diff -uNrd ircd-hybrid-6.0/include/s_auth.h ircd-pi1.0a/include/s_auth.h
--- ircd-hybrid-6.0/include/s_auth.h	Sun Jul 11 18:39:57 1999
+++ ircd-pi1.0a/include/s_auth.h	Fri Nov  2 19:23:23 2001
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_auth.h,v 1.2 1999/07/11 22:39:57 tomh Exp $
+ *   $Id: s_auth.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $
  */
 #ifndef INCLUDED_s_auth_h
 #define INCLUDED_s_auth_h
diff -uNrd ircd-hybrid-6.0/include/s_bsd.h ircd-pi1.0a/include/s_bsd.h
--- ircd-hybrid-6.0/include/s_bsd.h	Fri Apr 21 19:39:23 2000
+++ ircd-pi1.0a/include/s_bsd.h	Sun May  5 00:07:37 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_bsd.h,v 1.14 2000/04/21 23:39:23 lusky Exp $
+ *   $Id: s_bsd.h,v 1.3 2002/05/05 04:07:37 smoli Exp $
  *
  */
 #ifndef INCLUDED_s_bsd_h
@@ -49,6 +49,7 @@
 extern int   read_message (time_t, unsigned char);
 extern void  report_error(const char*, const char*, int);
 extern int   set_non_blocking(int);
+extern int   set_blocking(int);
 extern int   set_sock_buffers(int, int);
 extern int   send_queued(struct Client*);
 extern int   deliver_it(struct Client*, const char*, int);
diff -uNrd ircd-hybrid-6.0/include/s_conf.h ircd-pi1.0a/include/s_conf.h
--- ircd-hybrid-6.0/include/s_conf.h	Fri Dec  1 01:28:47 2000
+++ ircd-pi1.0a/include/s_conf.h	Tue May 21 22:14:28 2002
@@ -21,9 +21,30 @@
  */
 
 /*
- * $Id: s_conf.h,v 1.45 2000/12/01 06:28:47 lusky Exp $
+ * $Id: s_conf.h,v 1.4 2002/05/22 02:14:28 smoli Exp $
  *
  * $Log: s_conf.h,v $
+ * Revision 1.4  2002/05/22 02:14:28  smoli
+ * made listener, setuid, chroot, color and session stuff
+ *
+ * Revision 1.3  2002/05/18 04:05:57  smoli
+ * juhuuu
+ *
+ * Revision 1.2  2002/05/05 20:52:40  smoli
+ * guess host type
+ *
+ * Revision 1.1.1.1  2001/11/03 00:23:23  shifty
+ * yeyeh, here is it!
+ *
+ * Revision 1.1.1.1  2001/10/14 03:52:52  shifty
+ *
+ *
+ * Revision 1.1.1.1  2001/09/11 12:37:52  root
+ *
+ *
+ * Revision 1.1.1.1  2001/09/09 18:16:59  shifty
+ *
+ *
  * Revision 1.45  2000/12/01 06:28:47  lusky
  * added Gline Exemption flag ('_') to Ilines
  *
@@ -201,6 +222,7 @@
 #ifndef INCLUDED_motd_h
 #include "motd.h"               /* MessageFile */
 #endif
+#include "config.h"
 
 struct Client;
 struct SLink;
@@ -224,6 +246,7 @@
   time_t           hold;     /* Hold action until this time (calendar time) */
   struct Class*    c_class;     /* Class of connection */
   int              dns_pending; /* 1 if dns query pending, 0 otherwise */
+  int              connect_ssl; /* Used by C/N lines */
 };
 
 typedef struct QlineItem {
@@ -261,6 +284,9 @@
 #define CONF_DLINE              0x20000
 #define CONF_XLINE              0x40000
 #define CONF_ULINE              0x80000
+#ifdef HAVE_SSL
+#define CONF_SSL                0x100000
+#endif
 
 #define CONF_OPS                (CONF_OPERATOR | CONF_LOCOP)
 #define CONF_SERVER_MASK        (CONF_CONNECT_SERVER | CONF_NOCONNECT_SERVER)
@@ -358,6 +384,11 @@
 extern struct ConfItem *temporary_ip_klines;
 extern ConfigFileEntryType ConfigFileEntry;    /* GLOBAL - defined in ircd.c */
 
+#ifdef BACKUP
+extern struct ConfItem* main_link;
+extern struct ConfItem* backup_link;
+#endif /* BACKUP */
+
 extern void clear_ip_hash_table(void);
 extern void iphash_stats(struct Client *,struct Client *,int,char **,int);
 
@@ -370,7 +401,7 @@
 extern struct ConfItem* make_conf(void);
 extern void             free_conf(struct ConfItem*);
 
-extern void             read_conf_files(int cold);
+extern int              read_conf_files(int cold);
 
 extern struct DNSReply* conf_dns_lookup(struct ConfItem* aconf);
 extern int              attach_conf(struct Client*, struct ConfItem *);
@@ -396,6 +427,11 @@
                                      int);
 extern struct ConfItem* find_conf_by_name(const char* name, int status);
 extern struct ConfItem* find_conf_by_host(const char* host, int status);
+#ifdef BACKUP
+extern struct ConfItem *find_conf_main_link();
+extern struct ConfItem *find_conf_link_but();
+extern int count_conf_links();
+#endif /* BACKUP */
 extern struct ConfItem* find_kill (struct Client *);
 extern int conf_connect_allowed(struct in_addr addr);
 extern char *oper_flags_as_string(int);
diff -uNrd ircd-hybrid-6.0/include/s_debug.h ircd-pi1.0a/include/s_debug.h
--- ircd-hybrid-6.0/include/s_debug.h	Sat Jul 31 00:13:51 1999
+++ ircd-pi1.0a/include/s_debug.h	Fri Nov  2 19:23:23 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_debug.h,v 1.7 1999/07/31 04:13:51 tomh Exp $
+ *   $Id: s_debug.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $
  */
 #ifndef INCLUDED_s_debug_h
 #define INCLUDED_s_debug_h
diff -uNrd ircd-hybrid-6.0/include/s_log.h ircd-pi1.0a/include/s_log.h
--- ircd-hybrid-6.0/include/s_log.h	Wed Oct 13 22:48:24 1999
+++ ircd-pi1.0a/include/s_log.h	Sat May 18 00:05:57 2002
@@ -17,8 +17,9 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- * $Id: s_log.h,v 1.5 1999/10/14 02:48:24 lusky Exp $
+ * $Id: s_log.h,v 1.2 2002/05/18 04:05:57 smoli Exp $
  */
+
 #ifndef INCLUDED_s_log_h
 #define INCLUDED_s_log_h
 
@@ -34,7 +35,7 @@
 extern void close_log(void);
 extern void set_log_level(int level);
 extern int  get_log_level(void);
-extern void log(int priority, const char* fmt, ...);
+extern void *log(int priority, const char* fmt, ...);
 extern const char *get_log_level_as_string(int level);
 
 #endif /* INCLUDED_s_log_h */
diff -uNrd ircd-hybrid-6.0/include/s_misc.h ircd-pi1.0a/include/s_misc.h
--- ircd-hybrid-6.0/include/s_misc.h	Thu Oct  5 23:00:57 2000
+++ ircd-pi1.0a/include/s_misc.h	Fri Nov  2 19:23:23 2001
@@ -1,5 +1,5 @@
 /*
- * $Id: s_misc.h,v 1.7 2000/10/06 03:00:57 lusky Exp $ 
+ * $Id: s_misc.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $ 
  */
 
 #ifndef INCLUDED_s_misc_h
diff -uNrd ircd-hybrid-6.0/include/s_serv.h ircd-pi1.0a/include/s_serv.h
--- ircd-hybrid-6.0/include/s_serv.h	Fri Jul 30 02:48:11 1999
+++ ircd-pi1.0a/include/s_serv.h	Mon May  6 23:43:56 2002
@@ -17,7 +17,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- * $Id: s_serv.h,v 1.8 1999/07/30 06:48:11 tomh Exp $
+ * $Id: s_serv.h,v 1.3 2002/05/07 03:43:56 smoli Exp $
  *
  */
 #ifndef INCLUDED_serv_h
@@ -45,6 +45,8 @@
 #define CAP_EX          0x00000008      /* Can do channel +e exemptions */
 #define CAP_CHW         0x00000010      /* Can do channel wall @# */
 #define CAP_DE          0x00000020      /* Can do channel +d (regex deny) */
+#define CAP_RW          0x00000040      /* Can handle remote whois */
+#define CAP_SSL         0x00000080      /* Uses SSL links */
 
 #define DoesCAP(x)      ((x)->caps)
 
@@ -67,6 +69,9 @@
 
 extern int MaxClientCount;     /* GLOBAL - highest number of clients */
 extern int MaxConnectionCount; /* GLOBAL - highest number of connections */
+#ifdef BACKUP
+extern struct Client* backup_drop;
+#endif /* BACKUP */
 
 /* 
  * allow DEFAULT_SERVER_SPLIT_RECOVERY_TIME minutes after server rejoins
@@ -100,7 +105,10 @@
 extern const char* show_capabilities(struct Client* client);
 extern void        show_servers(struct Client *);
 extern time_t      try_connections(time_t currenttime);
-
+#ifdef BACKUP
+extern void        backup_lost_link(struct Client *);
+extern int         backup_regain_link(struct Client *);
+#endif /* BACKUP */
 #endif /* INCLUDED_s_serv_h */
 
 
diff -uNrd ircd-hybrid-6.0/include/s_stats.h ircd-pi1.0a/include/s_stats.h
--- ircd-hybrid-6.0/include/s_stats.h	Fri Jul 30 16:14:04 1999
+++ ircd-pi1.0a/include/s_stats.h	Fri Nov  2 19:23:23 2001
@@ -18,7 +18,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- * $Id: s_stats.h,v 1.1 1999/07/30 20:14:04 tomh Exp $
+ * $Id: s_stats.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $
  */
 #ifndef INCLUDED_s_stats_h
 #define INCLUDED_s_stats_h
diff -uNrd ircd-hybrid-6.0/include/s_user.h ircd-pi1.0a/include/s_user.h
--- ircd-hybrid-6.0/include/s_user.h	Fri Jul 30 22:44:44 1999
+++ ircd-pi1.0a/include/s_user.h	Tue May 14 00:03:44 2002
@@ -19,7 +19,7 @@
  *
  * "s_user.h". - Headers file.
  *
- * $Id: s_user.h,v 1.9 1999/07/31 02:44:44 tomh Exp $
+ * $Id: s_user.h,v 1.2 2002/05/14 04:03:44 smoli Exp $
  *
  */
 #ifndef INCLUDED_s_user_h
@@ -44,6 +44,7 @@
 extern void  send_umode_out (struct Client*, struct Client *, int);
 extern int   show_lusers(struct Client *, struct Client *, int, char **);
 extern void  show_opers(struct Client* client);
+extern int   valid_hostname(const char* hostname);
 
 
 #endif
diff -uNrd ircd-hybrid-6.0/include/s_zip.h ircd-pi1.0a/include/s_zip.h
--- ircd-hybrid-6.0/include/s_zip.h	Fri Jul 23 03:02:43 1999
+++ ircd-pi1.0a/include/s_zip.h	Mon May  6 23:43:56 2002
@@ -19,7 +19,7 @@
  *
  * "s_zip.h". - Headers file.
  *
- * $Id: s_zip.h,v 1.2 1999/07/23 07:02:43 tomh Exp $
+ * $Id: s_zip.h,v 1.2 2002/05/07 03:43:56 smoli Exp $
  *
  */
 #ifndef INCLUDED_s_zip_h
@@ -28,7 +28,7 @@
 #include "config.h"       /* config settings */
 #endif
 #ifndef INCLUDED_zlib_h
-#include "zlib.h"         /* z_stream */
+#include <zlib.h>         /* z_stream */
 #define INCLUDED_zlib_h
 #endif
 
diff -uNrd ircd-hybrid-6.0/include/scache.h ircd-pi1.0a/include/scache.h
--- ircd-hybrid-6.0/include/scache.h	Wed Jul 21 22:44:22 1999
+++ ircd-pi1.0a/include/scache.h	Fri Nov  2 19:23:23 2001
@@ -19,7 +19,7 @@
  *
  * "scache.h". - Headers file.
  *
- * $Id: scache.h,v 1.1 1999/07/22 02:44:22 db Exp $
+ * $Id: scache.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $
  *
  */
 #ifndef INCLUDED_scache_h
diff -uNrd ircd-hybrid-6.0/include/send.h ircd-pi1.0a/include/send.h
--- ircd-hybrid-6.0/include/send.h	Fri Nov 24 12:36:25 2000
+++ ircd-pi1.0a/include/send.h	Wed May 22 07:07:10 2002
@@ -2,7 +2,7 @@
  * send.h
  * Copyright (C) 1999 Patrick Alken
  *
- * $Id: send.h,v 1.13 2000/11/24 17:36:25 lusky Exp $
+ * $Id: send.h,v 1.3 2002/05/22 11:07:10 smoli Exp $
  */
 
 #ifndef INCLUDED_send_h
@@ -58,6 +58,7 @@
 extern  void sendto_ops_flags(int, const char *, ...);
 
 extern  void sendto_realops(const char *, ...);
+extern  void sendto_realops_lev(int, const char *, ...);
 extern  void sendto_realops_flags(int, const char *, ...);
 
 extern  void sendto_ops(const char *, ...);
@@ -65,6 +66,7 @@
                                const char *, ...);
 extern  void sendto_wallops_butone(struct Client *, struct Client *, 
                                    const char *, ...);
+extern  void sendto_myclients(struct Client *, const char *, ...);
 extern  void ts_warn(const char *, ...);
 
 extern  void sendto_prefix_one(struct Client *, struct Client *, 
diff -uNrd ircd-hybrid-6.0/include/serno.h ircd-pi1.0a/include/serno.h
--- ircd-hybrid-6.0/include/serno.h	Wed Jan  3 22:31:11 2001
+++ ircd-pi1.0a/include/serno.h	Fri Nov  2 19:23:23 2001
@@ -1 +1 @@
-#define SERIALNUM "20010103_2"
+#define SERIALNUM "20010909_3"
diff -uNrd ircd-hybrid-6.0/include/setup.h.in ircd-pi1.0a/include/setup.h.in
--- ircd-hybrid-6.0/include/setup.h.in	Thu Oct  5 23:00:57 2000
+++ ircd-pi1.0a/include/setup.h.in	Thu May 23 13:58:28 2002
@@ -1,72 +1,106 @@
-/* include/setup.h.in.  Generated automatically from configure.in by autoheader.
- *
- * $Id: setup.h.in,v 1.6 2000/10/06 03:00:57 lusky Exp $ 
- */
+/* include/setup.h.in.  Generated from configure.in by autoheader.  */
 
-/* Define if you need to in order for stat and other things to work.  */
-#undef _POSIX_SOURCE
+/* Define this if your server has an alternative uplink */
+#undef BACKUP
 
-/* Define if you have the ANSI C header files.  */
-#undef STDC_HEADERS
+/* Enable debugging mode */
+#undef DEBUG
 
-/* Define only one of POSIX, BSD, or SYSV signals.  */
-/* Define if your system has reliable POSIX signals.  */
-#undef POSIX_SIGNALS
+/* Define this if you want your IRCops to enforce */
+#undef ENFORCE
 
-/* Define if your system has reliable BSD signals.  */
-#undef BSD_RELIABLE_SIGNALS
+/* Define to 1 if you have the <errno.h> header file. */
+#undef HAVE_ERRNO_H
 
-/* Define if your system has unreliable SYSV signals.  */
-#undef SYSV_UNRELIABLE_SIGNALS
+/* Define to 1 if you have the <getopt.h> header file. */
+#undef HAVE_GETOPT_H
 
-/* Define if you have the poll() system call.  */
-#undef USE_POLL
+/* Define to 1 if you have the <inttypes.h> header file. */
+#undef HAVE_INTTYPES_H
 
-/* Chose only one of NBLOCK_POSIX, NBLOCK_BSD, and NBLOCK_SYSV */
-/* Define if you have posix non-blocking sockets (O_NONBLOCK) */
-#undef NBLOCK_POSIX
+/* Define to 1 if you have the `crypt' library (-lcrypt). */
+#undef HAVE_LIBCRYPT
 
-/* Define if you have BSD non-blocking sockets (O_NDELAY) */
-#undef NBLOCK_BSD
+/* Define to 1 if you have the `descrypt' library (-ldescrypt). */
+#undef HAVE_LIBDESCRYPT
 
-/* Define if you have SYSV non-blocking sockets (FIONBIO) */
-#undef NBLOCK_SYSV
+/* Define to 1 if you have the `nsl' library (-lnsl). */
+#undef HAVE_LIBNSL
 
-/* Define if you have the mmap() function.  */
-#undef USE_MMAP
+/* Define to 1 if you have the `resolv' library (-lresolv). */
+#undef HAVE_LIBRESOLV
 
-/* Define if you are running SOLARIS2.  */
-#undef OS_SOLARIS2
+/* Define to 1 if you have the `socket' library (-lsocket). */
+#undef HAVE_LIBSOCKET
 
-/* Define if you have the <errno.h> header file.  */
-#undef HAVE_ERRNO_H
+/* Define to 1 if you have the `z' library (-lz). */
+#undef HAVE_LIBZ
 
-/* Define if you have the <stddef.h> header file.  */
+/* Define to 1 if you have the <memory.h> header file. */
+#undef HAVE_MEMORY_H
+
+/* Define this if OpenSSL has ASN1_UTCTIME_get */
+#undef HAVE_SSL
+
+/* Define to 1 if you have the <stddef.h> header file. */
 #undef HAVE_STDDEF_H
 
-/* Define if you have the <stdlib.h> header file.  */
+/* Define to 1 if you have the <stdint.h> header file. */
+#undef HAVE_STDINT_H
+
+/* Define to 1 if you have the <stdlib.h> header file. */
 #undef HAVE_STDLIB_H
 
-/* Define if you have the <string.h> header file.  */
+/* Define to 1 if you have the <strings.h> header file. */
+#undef HAVE_STRINGS_H
+
+/* Define to 1 if you have the <string.h> header file. */
 #undef HAVE_STRING_H
 
-/* Define if you have the <sys/param.h> header file.  */
+/* Define to 1 if you have the <sys/param.h> header file. */
 #undef HAVE_SYS_PARAM_H
 
-/* Define if you have the <unistd.h> header file.  */
+/* Define to 1 if you have the <sys/stat.h> header file. */
+#undef HAVE_SYS_STAT_H
+
+/* Define to 1 if you have the <sys/types.h> header file. */
+#undef HAVE_SYS_TYPES_H
+
+/* Define to 1 if you have the <unistd.h> header file. */
 #undef HAVE_UNISTD_H
 
-/* Define if you have the <getopt.h> header file.  */
-#undef HAVE_GETOPT_H
+/* Define this if you want to run your server as a hub */
+#undef HUB
 
-/* Define if you have the descrypt library (-ldescrypt).  */
-#undef HAVE_LIBDESCRYPT
+/* IRCD server root */
+#undef IRCDDIR
 
-/* Define if you have the nsl library (-lnsl).  */
-#undef HAVE_LIBNSL
+/* IRCD user */
+#undef IRCDUSER
 
-/* Define if you have the resolv library (-lresolv).  */
-#undef HAVE_LIBRESOLV
+/* Name of package */
+#undef PACKAGE
 
-/* Define if you have the socket library (-lsocket).  */
-#undef HAVE_LIBSOCKET
+/* Define to the address where bug reports for this package should be sent. */
+#undef PACKAGE_BUGREPORT
+
+/* Define to the full name of this package. */
+#undef PACKAGE_NAME
+
+/* Define to the full name and version of this package. */
+#undef PACKAGE_STRING
+
+/* Define to the one symbol short name of this package. */
+#undef PACKAGE_TARNAME
+
+/* Define to the version of this package. */
+#undef PACKAGE_VERSION
+
+/* Define to 1 if you have the ANSI C header files. */
+#undef STDC_HEADERS
+
+/* Define this if you have the poll() system call */
+#undef USE_POLL
+
+/* Version number of package */
+#undef VERSION
diff -uNrd ircd-hybrid-6.0/include/sprintf_irc.h ircd-pi1.0a/include/sprintf_irc.h
--- ircd-hybrid-6.0/include/sprintf_irc.h	Thu Oct  5 23:00:57 2000
+++ ircd-pi1.0a/include/sprintf_irc.h	Fri Nov  2 19:23:23 2001
@@ -1,5 +1,5 @@
 /*
- * $Id: sprintf_irc.h,v 1.2 2000/10/06 03:00:57 lusky Exp $ 
+ * $Id: sprintf_irc.h,v 1.1.1.1 2001/11/03 00:23:23 shifty Exp $ 
  */
 
 #ifndef SPRINTF_IRC
diff -uNrd ircd-hybrid-6.0/include/ssl.h ircd-pi1.0a/include/ssl.h
--- ircd-hybrid-6.0/include/ssl.h	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/include/ssl.h	Thu May 23 00:22:22 2002
@@ -0,0 +1,38 @@
+#ifndef INCLUDED_s_ssl_h
+#define INCLUDED_s_ssl_h
+
+#include "setup.h"
+
+#ifdef HAVE_SSL
+
+/* OpenSSL includes */
+#include <openssl/rsa.h>       
+#include <openssl/crypto.h>
+#include <openssl/x509.h>
+#include <openssl/pem.h>
+#include <openssl/ssl.h>
+#include <openssl/err.h>
+#include "client.h"
+
+#define RANDOM_SIZE 168 /* size of random seed */
+
+extern int ssl_capable;
+extern int ssl_cvl;
+extern int ssl_svl;
+extern char *ssl_cipher_list;
+extern char *ssl_pem_passphrase;
+extern SSL_CTX* server_ctx;
+extern SSL_CTX* client_ctx;
+extern SSL_METHOD *server_meth;
+extern SSL_METHOD *client_meth;
+extern int ssl_init();
+extern int ssl_seed_prng(char *filename);
+extern int ssl_read(struct Client *, void *, size_t);
+extern int ssl_write(struct Client *, const void *, size_t);
+extern int ssl_connect(struct Client *);  
+extern int ssl_accept(struct Client *, int);
+extern int ssl_shutdown(SSL *);
+  
+#endif /* HAVE_SSL */
+
+#endif /* INCLUDED_s_ssl_h */
diff -uNrd ircd-hybrid-6.0/include/struct.h ircd-pi1.0a/include/struct.h
--- ircd-hybrid-6.0/include/struct.h	Sun Aug  1 03:19:44 1999
+++ ircd-pi1.0a/include/struct.h	Fri Nov  2 19:23:24 2001
@@ -17,7 +17,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- * $Id: struct.h,v 1.85 1999/08/01 07:19:44 tomh Exp $
+ * $Id: struct.h,v 1.1.1.1 2001/11/03 00:23:24 shifty Exp $
  */
 #ifndef INCLUDED_struct_h
 #define INCLUDED_struct_h
diff -uNrd ircd-hybrid-6.0/include/whowas.h ircd-pi1.0a/include/whowas.h
--- ircd-hybrid-6.0/include/whowas.h	Thu Oct  5 23:00:58 2000
+++ ircd-pi1.0a/include/whowas.h	Fri Nov  2 19:23:24 2001
@@ -18,7 +18,7 @@
  */
 
 /*
- * $Id: whowas.h,v 1.6 2000/10/06 03:00:58 lusky Exp $
+ * $Id: whowas.h,v 1.1.1.1 2001/11/03 00:23:24 shifty Exp $
  */
 #ifndef INCLUDED_whowas_h
 #define INCLUDED_whowas_h
